"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodePage = void 0;
const component_1 = require("@teambit/component");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const lodash_1 = require("lodash");
const base_ui_surfaces_split_pane_split_pane_1 = require("@teambit/base-ui.surfaces.split-pane.split-pane");
const base_ui_surfaces_split_pane_hover_splitter_1 = require("@teambit/base-ui.surfaces.split-pane.hover-splitter");
const ui_buttons_collapser_1 = require("@teambit/ui.buttons.collapser");
const ui_queries_get_component_code_1 = require("@teambit/ui.queries.get-component-code");
const ui_utils_get_file_icon_1 = require("@teambit/ui.utils.get-file-icon");
const ui_code_view_1 = require("@teambit/ui.code-view");
const ui_code_tab_tree_1 = require("@teambit/ui.code-tab-tree");
const ui_hooks_use_code_params_1 = require("@teambit/ui.hooks.use-code-params");
const ui_hooks_use_is_mobile_1 = require("@teambit/ui.hooks.use-is-mobile");
const code_tab_page_module_scss_1 = __importDefault(require("./code-tab-page.module.scss"));
function CodePage({ className, fileIconSlot }) {
    const fileName = ui_hooks_use_code_params_1.useCodeParams();
    const component = react_1.useContext(component_1.ComponentContext);
    const { mainFile, fileTree = [], dependencies, devFiles } = ui_queries_get_component_code_1.useCode(component.id);
    const fileFromUrl = react_1.useMemo(() => {
        return fileName.file;
    }, [fileName]);
    const currentFile = fileFromUrl || mainFile;
    const isMobile = ui_hooks_use_is_mobile_1.useIsMobile();
    const [isSidebarOpen, setSidebarOpenness] = react_1.useState(!isMobile);
    const sidebarOpenness = isSidebarOpen ? base_ui_surfaces_split_pane_split_pane_1.Layout.row : base_ui_surfaces_split_pane_split_pane_1.Layout.left;
    const fileIconMatchers = react_1.useMemo(() => lodash_1.flatten(fileIconSlot === null || fileIconSlot === void 0 ? void 0 : fileIconSlot.values()), [fileIconSlot]);
    const icon = ui_utils_get_file_icon_1.getFileIcon(fileIconMatchers, currentFile);
    return (react_1.default.createElement(base_ui_surfaces_split_pane_split_pane_1.SplitPane, { layout: sidebarOpenness, size: "85%", className: classnames_1.default(code_tab_page_module_scss_1.default.codePage, className) },
        react_1.default.createElement(base_ui_surfaces_split_pane_split_pane_1.Pane, { className: code_tab_page_module_scss_1.default.left },
            react_1.default.createElement(ui_code_view_1.CodeView, { componentId: component.id, currentFile: currentFile, icon: icon })),
        react_1.default.createElement(base_ui_surfaces_split_pane_hover_splitter_1.HoverSplitter, { className: code_tab_page_module_scss_1.default.splitter },
            react_1.default.createElement(ui_buttons_collapser_1.Collapser, { placement: "left", isOpen: isSidebarOpen, onMouseDown: (e) => e.stopPropagation(), onClick: () => setSidebarOpenness((x) => !x), tooltipContent: `${isSidebarOpen ? 'Hide' : 'Show'} file tree`, className: code_tab_page_module_scss_1.default.collapser })),
        react_1.default.createElement(base_ui_surfaces_split_pane_split_pane_1.Pane, { className: code_tab_page_module_scss_1.default.right },
            react_1.default.createElement(ui_code_tab_tree_1.CodeTabTree, { currentFile: currentFile, dependencies: dependencies, fileTree: fileTree, devFiles: devFiles, mainFile: mainFile, fileIconMatchers: fileIconMatchers }))));
}
exports.CodePage = CodePage;
//# sourceMappingURL=code-tab-page.js.map